import javax.media.opengl.GL;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLEventListener;
import javax.media.opengl.GLJPanel;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JSlider;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.vecmath.Point3f;
import javax.vecmath.Vector3f;

import com.sun.opengl.util.BufferUtil;
import com.sun.opengl.util.FPSAnimator;
import com.sun.opengl.util.texture.Texture;

import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.media.opengl.glu.GLU;
import javax.swing.JApplet;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.awt.event.MouseMotionListener;
import java.awt.geom.Point2D;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.FloatBuffer;
import java.util.ArrayList;
import java.util.Scanner;
/** VBOでモデルを表示します */
public class Web_GIS_1_9 extends JApplet implements GLEventListener,
		KeyListener, MouseListener, MouseMotionListener, ActionListener,
		ChangeListener, ListSelectionListener {
	// FrameRate temp = new FrameRate();

	// レイアウト用のパネル
	private GLJPanel panel = new GLJPanel();
	private GLJPanel panel2 = new GLJPanel();
	private GLJPanel panel3 = new GLJPanel();
	private GLJPanel panel4 = new GLJPanel();
	private GLJPanel panel5 = new GLJPanel();
	private GL gl;
	GLU gll;

	GLAutoDrawable glaa;
	// 各バッファオブジェクトの番号です
	private int vboIdVertex;
	private int vboIdNormal;
	private int vboIdcolor;
	private int vboIdmy; // 緯線・経線用バッファ
	private int vboIdmy2; // 緯線・経線の色バッファ

	private FloatBuffer vertexBuffer = null;
	private FloatBuffer normalBuffer = null;
	private FloatBuffer colorBuffer = null;
	private FloatBuffer myBuffer = null;
	private FloatBuffer myBuffer2 = null;

	private float cameraX = 0.0f, cameraZ = 10.0f; // カメラの座標です
	private float cameraAngle = 0.0f; // カメラの角度です
	private final float CAMERASPEED = 0.5f; // カメラの移動速度です
	//private Rotate Rotatew;

	int totalvertex; // 頂点の総数
	int totalmapping; // マッピングデータの総数
	int totalindex; // 組合せの総数
	float vertices[][]; // 頂点を入れる配列
	int index[][]; // 組合せを入れる配列
	int total_latlon_W; // latlonの総数
	int total_latlon_R; // latlonの総数
	float latlon_line_W[][]; // 頂点を入れる配列
	float latlon_line_R[][]; // 頂点を入れる配列

	float M_C_0[];// 読み込んだマッピングデータを入れる配列
	float M_C_1[];
	float M_C_2[];
	float M_C_3[];
	float M_C_4[];
	float M_C_5[];
	
	int M_C_NO[];
	float M_RGB_0[][];// RGBマッピングデータを入れる配列
	float MAX_m = 0;
	float min_m = 10.0f;

	java.net.URL mapping_0 = null;

	int latlon = 0;

	String LABEL = "#LABEL";
	String UNIT = "#UNIT";
	ArrayList Labrl_list = new ArrayList();

	float normals[][];// 各面の法線
	int normalIndex[];// 法線のインデックス

	// // テクスチャの設定です
	// private Texture texture;
	// private float[][]  = new float[][] {};

	// 光源の設定です
	private float[] lightPosition = { -5.0f, 5.0f, 5.0f, 0.0f }; // 平行光源です
	private float[] lightSpecular = { 0.5f, 0.5f, 0.5f, 1.0f }; // 反射光の強さです
	// private float[] lightSpecular = { 0.7f, 0.7f, 0.7f, 1.0f }; // 反射光の強さです
	private float[] lightDiffuse = { 0.5f, 0.5f, 0.5f, 1.0f }; // 拡散光の強さです
	private float[] lightAmbient = { 0.2f, 0.2f, 0.2f, 1.0f }; // 環境光の強さです

	// 立方体の反射率です
	private float[] cubeSpecular = { 0.5f, 0.5f, 0.5f, 1.0f };
	private float[] cubeDiffuse = { 0.5f, 0.5f, 0.5f, 1.0f };
	private float[] cubeAmbient = { 0.2f, 0.2f, 0.2f, 1.0f };
	private float cubeShiness = 5.0f; // ハイライトの強さです

	private int counter = 0; // 表示回数のカウンターです

	private int prevMouseX;
	private float prevMouseY;

	// 情報取得時マウス座標関連
	double[] scale = new double[2];
	double mouseX, mouseY;
	Point2D.Double mousePos = new Point2D.Double();

	// 情報取得時必要なモデルビュー行列、射影行列、ビューポート変換行列
	// ポリゴン検索時は必ず、eachポリゴンを正規ビューボリュームに投影するため、射影行列、ビューポート変換行列は正規ビューボリューム
	// 用にここで初期化（変化しない）
	// モデルビュー変換行列は回転操作等の度、行列の値が変わるので、その都度行列を得る。
	// 正規ビューボリュームはx[-1, 1], y[-1, 1],z[-1, 1]のビューボリューム
	double[] modelview = new double[16];
	double[] projection = { 5.0, 0.0, 0.0, 0.0, 0.0, 5.0, 0.0, 0.0, 0.0, 0.0,
			-1.2857142686843872, -1.0, 0.0, 0.0, -11.428571701049805, 0.0 };
	int[] viewport = { -1, -1, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

	// 変換行列により、スクリーン座標に変換される頂点座標
	double[] result = new double[9];

	private int wi = 0;
	private int he = 0;

	// ポリゴンインデックス
	int indexP;
	int count;

	private float angleX = 0.0f;
	private float angleY = 0.0f;
	private float distanceX = 0.0f;
	private float distanceY = 0.0f;
	public float vp = 0.0f; // 視点の位置（拡大縮小）

	public float currentscale;

	private FPSAnimator anim; // アニメーション用のオブジェクトです

	float mx, my;

	JButton L_L;// 緯線・経線ボタン
	JButton CL;// マッピングデータのクリアボタン
	JLabel label1;// ポリゴン情報の表示用ラベル
	JSlider slider_b;
	JSlider slider_e;
	JList lst;// マッピングデータのリスト
	JTextArea area1;

	int ID;// ポリゴンID
	int J = 0;

	int Initial;//グレースケールのイトカワを表示するフラグ

	//スライドバーの初期値
	int d1s_b=1000;
	int d1s_e=0;
	int d2s_b=608;
	int d2s_e=70;
	int d3s_b=796;
	int d3s_e=636;
	int d4s_b=935;
	int d4s_e=908;
	int d5s_b=791;
	int d5s_e=648;


	int d0s_b=700;
	int d0s_e=0;

	float color_scale = d0s_b/100f;
	int L ;
	int L1 ;
	
	float saturation =1.0f;
	float value =1.0f;
	
	float begin=240f;
	float end=0f;
	float hue;
	int MAXrange=1000;
	int minrange=0;

	
	/** アプレットの初期化処理です */
	public void init() {
		System.out.println("アプレットのinit開始");

		// setLayout(new GridLayout(2, 1));
		// add(panel);
		// add(panel2);
		panel.setPreferredSize(new Dimension(650, 500));
		panel2.setPreferredSize(new Dimension(415, 20));
		panel3.setPreferredSize(new Dimension(415, 20));
		panel4.setPreferredSize(new Dimension(626, 125));
		panel5.setPreferredSize(new Dimension(310, 25));
		panel.addGLEventListener(this);

		this.addMouseMotionListener(this);
		this.addMouseListener(this);
		this.addKeyListener(this);

		anim = new FPSAnimator(panel, 60, false); // JPanelをアニメーション対象にセットします
		anim.start(); // アニメーションをスタートさせます
		//
		// panel.setLayout(new GridLayout(1, 1));
		// panel2.setLayout(new GridLayout(1, 3));

		Container contentPane = getContentPane();
		contentPane.setLayout(new FlowLayout(FlowLayout.CENTER, 0, 0));

		contentPane.add(panel);
		panel.setLayout(new GridLayout(1, 1));

		contentPane.add(panel2);
		panel2.setLayout(new GridLayout(1, 1));
		slider_b = new JSlider(0, 1000);
		slider_b.setValue(d0s_b);
		slider_b.setBackground(Color.white);
		slider_b.setOpaque(true);
		slider_b.addChangeListener(this);

		panel2.add(slider_b);
		
		contentPane.add(panel3);
		panel3.setLayout(new GridLayout(1, 1));
		slider_e = new JSlider(0, 1000);
		slider_e.setValue(d0s_e);
		slider_e.setBackground(Color.white);
		slider_e.setOpaque(true);
		slider_e.addChangeListener(this);

		panel3.add(slider_e);


		contentPane.add(panel4);
		panel4.setLayout(new GridLayout(1, 2));

		String[] data = { "Gravitational potential", "Surface slope", "AMICA brightness","NIRS albedo", "Degree of space weathering" };
		lst = new JList(data);
		lst.addListSelectionListener(this);
		panel4.add(lst);

		area1 = new JTextArea();

		area1.setEditable(false);
		area1.setForeground(Color.black);
		area1.setBackground(Color.white);
		area1.setOpaque(true);
		area1.setFont(new Font("SANS_SERIF", Font.BOLD, 12));

		area1.setText("PolygonID :\nGravitational Potential : \nSurface slope :\nAMICA brightness :\nNIRS albedo :\nDegree of space weathering :");
		panel4.add(area1);

		// label1.setVerticalAlignment(SwingConstants.TOP);

		contentPane.add(panel5);
		panel5.setLayout(new GridLayout(1, 2));
		L_L = new JButton("Lat-Long Grid");
		L_L.setBackground(Color.white);
		L_L.setOpaque(true);
		L_L.addActionListener(this);

		panel5.add(L_L);

		CL = new JButton("Clear Mapping Data");
		CL.addActionListener(this);
		CL.setBackground(Color.white);
		CL.setOpaque(true);
		panel5.add(CL);

		this.setSize(650, 690);
	}

	/** JOGLの初期化処理です */
	public void init(GLAutoDrawable gla) {
		System.out.println("JOGLのinit開始");
		gll = new GLU();
		gl = gla.getGL();
		gl.glEnable(GL.GL_LIGHTING); // 光源を有効にします
		gl.glEnable(GL.GL_COLOR_MATERIAL); // カラーマテリアルを有効にします
		gl.glEnable(GL.GL_LIGHT0); // 0番のライトを有効にします

		java.net.URL this_url = null;

		// ポリゴンデータの読み込み
		try {
			this_url = this.getClass().getClassLoader()
					.getResource("itokawa_f0049152");
			// this_url =
			// this.getClass().getClassLoader().getResource("itokawa_takusan");
			// this_url_for_high =
			// this.getClass().getClassLoader().getResource("data.txt");

			java.io.InputStream is = this_url.openStream();

			Scanner scan = new Scanner(is);

			totalvertex = scan.nextInt(); // 頂点の総数を読み込む
			vertices = new float[totalvertex][3];
			for (int i = 0; i < totalvertex; i++) {
				int vertexNo = scan.nextInt();
				vertices[i][0] = scan.nextFloat();
				vertices[i][1] = scan.nextFloat();
				vertices[i][2] = scan.nextFloat();
				// System.out.println(vertices[i][2]);
			}

			totalindex = scan.nextInt();

			// System.out.println(totalindex);
			index = new int[totalindex][3];
			for (int i = 0; i < totalindex; i++) {
				int indexNo = scan.nextInt();
				index[i][0] = scan.nextInt();
				index[i][1] = scan.nextInt();
				index[i][2] = scan.nextInt();
				// System.out.println(index[i][2]);
			}
			scan.close();
		} catch (Exception e) {
			System.out.println(e);
			System.out.println("ガッ2");
		}
		// ////////////////////////////////////////////////////////////////////////////////
		try {
			this_url = this.getClass().getClassLoader()
					.getResource("Lat_Lon_W.txt");

			java.io.InputStream is = this_url.openStream();

			Scanner scan_LatLon_W = new Scanner(is);

			total_latlon_W = scan_LatLon_W.nextInt(); // 頂点の総数を読み込む
			latlon_line_W = new float[total_latlon_W][3];
			for (int i = 0; i < total_latlon_W; i++) {
				int latlonNo = scan_LatLon_W.nextInt();
				latlon_line_W[i][0] = scan_LatLon_W.nextFloat();
				latlon_line_W[i][1] = scan_LatLon_W.nextFloat();
				latlon_line_W[i][2] = scan_LatLon_W.nextFloat();
				// System.out.println(vertices[i][2]);
			}

			scan_LatLon_W.close();
		} catch (Exception e) {
			System.out.println(e);
			System.out.println("ガッ2");
		}

		// ////////////////////////////////////////////////////////////////////////////////

		// ////////////////////////////////////////////////////////////////////////////////
		 try {
		 this_url = this.getClass().getClassLoader()
		 .getResource("Lat_Lon_R.txt");

		 java.io.InputStream is = this_url.openStream();

		 Scanner scan_LatLon_R = new Scanner(is);

		 total_latlon_R = scan_LatLon_R.nextInt(); // 頂点の総数を読み込む
		 latlon_line_R = new float[total_latlon_R][3];
		 for (int i = 0; i < total_latlon_R; i++) {
		 int latlonNo = scan_LatLon_R.nextInt();
		 latlon_line_R[i][0] = scan_LatLon_R.nextFloat();
		 latlon_line_R[i][1] = scan_LatLon_R.nextFloat();
		 latlon_line_R[i][2] = scan_LatLon_R.nextFloat();
		 // System.out.println(vertices[i][2]);
		 }

		 scan_LatLon_R.close();
		 } catch (Exception e) {
		 System.out.println(e);
		 System.out.println("ガッ3");
		 }

		// ////////////////////////////////////////////////////////////////////////////////

		// マッピングファイルの読み込み
		mapping_0 = this.getClass().getClassLoader()
			.getResource("itokawa_Gpotential20110111.dat");
	//		mapping_0 = this.getClass().getClassLoader()
	//		.getResource("NIRS_20071227.dat");

		M_C_1 = color_input(mapping_0);

		// M_C_1 = color_input(mapping_0);

		mapping_0 = this.getClass().getClassLoader()
				.getResource("itokawa_slope20110111.dat");

		M_C_2 = color_input(mapping_0);

		mapping_0 = this.getClass().getClassLoader()
				.getResource("amica_brightness.txt");

		M_C_3 = color_input(mapping_0);

		mapping_0 = this.getClass().getClassLoader().getResource("NIRS_ch30_11_1_13.txt");

		M_C_4 = color_input(mapping_0);
		
		mapping_0 = this.getClass().getClassLoader().getResource("itokawa_sw.dat");//北里先生からもらい次第入れる

		M_C_5 = color_input(mapping_0);

		// data_change(M_C_1);
		Initial =1;
		InitialColor();
		normals = new float[totalindex][3];
		normalIndex = new int[totalindex * 3];
		System.out.println(normals);
		// ポリゴンの各頂点を指定する
		for (int i = 0 ;i < (totalindex);i++) {

			Point3f p0 = new Point3f(vertices[(index[i][0] - 1)][0],
					vertices[(index[i][0] - 1)][1],
					vertices[(index[i][0] - 1)][2]);
			Point3f p1 = new Point3f(vertices[(index[i][1] - 1)][0],
					vertices[(index[i][1] - 1)][1],
					vertices[(index[i][1] - 1)][2]);
			Point3f p2 = new Point3f(vertices[(index[i][2] - 1)][0],
					vertices[(index[i][2] - 1)][1],
					vertices[(index[i][2] - 1)][2]);

			Vector3f v1 = new Vector3f(p1.x - p0.x, p1.y - p0.y, p1.z - p0.z);
			Vector3f v2 = new Vector3f(p2.x - p0.x, p2.y - p0.y, p2.z - p0.z);

			Vector3f normal = new Vector3f();

			normal.cross(v1, v2); // 外積を求める
			//System.out.println(totalindex);
			normal.normalize();

			gl.glNormal3f(normal.x, normal.y, normal.z);

			normals[i][0] = normal.x;
			//System.out.println(normals[i][0]);
			normals[i][1] = normal.y;
			//System.out.println(normals[i][1]);
			normals[i][2] = normal.z;
			//System.out.println(normals[i][2]);
         	//System.out.println(i + " " + normals[i][2]);
			normalIndex[i * 3] = i;
			normalIndex[(i * 3) + 1] = i;
			normalIndex[(i * 3) + 2] = i;
			
		}

		
		// 頂点バッファオブジェクトを作成します
		this.compile(gl);

		System.out.println("VBO関連initの初期化終了");

	}

	/** 画面サイズ変更時の処理です */
	public void reshape(GLAutoDrawable arg0, int x, int y, int width, int height) {

		wi = width;
		he = height;
		System.out.println(wi + " " + he);

		float aspect = (float) width / (float) height;

		gl.glViewport(0, 0, width, height); // 描画領域を指定します

		gl.glMatrixMode(GL.GL_PROJECTION); // 投影行列を操作することを宣言します
		gl.glLoadIdentity(); // 単位行列を読み込みます
		gl.glFrustum(-aspect / 10, aspect / 10, -0.1f, 0.1f, 3.0f, 30.0f); // 投影する範囲を指定します

		gl.glGetDoublev(GL.GL_PROJECTION_MATRIX, projection, 0);

		gl.glMatrixMode(GL.GL_MODELVIEW); // モデルビュー行列を操作することを宣言します
		gl.glLoadIdentity(); // 単位行列を読み込みます
		gl.glTranslatef(0.0f, 0.0f, -10); // モデル全体を、Z軸に対して-10動かします

		gl.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
		// gl.glClearColor(0.25f, 0.25f, 0.25f, 1.0f);

		// z方向に平行移動をしているため、ここでモデルビュー行列を取得
		gl.glGetDoublev(GL.GL_MODELVIEW_MATRIX, modelview, 0);
	}

	/** 再描画の際に呼ばれる処理です */
	public void display(GLAutoDrawable arg0) {
		glaa = arg0;

		gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT); // 画面をクリアします
		gl.glEnable(GL.GL_DEPTH_TEST); // 奥行き判定を有効にします
		gl.glEnable(GL.GL_CULL_FACE); // 裏返ったポリゴンを描画しません

		gl.glLoadIdentity(); // 単位行列を読み込みます
		// gl.glRotatef(-cameraAngle, 0, 1.0f, 0); // 座標系をカメラの向きと逆に回転させます
		gl.glTranslatef(-cameraX, 0, -cameraZ); // 原点をカメラの位置とは逆に移動させます

		gl.glLightfv(GL.GL_LIGHT0, GL.GL_POSITION, lightPosition, 0); // 平行光源を設定します
		gl.glLightfv(GL.GL_LIGHT0, GL.GL_SPECULAR, lightSpecular, 0); // 反射光の強さを設定します
		gl.glLightfv(GL.GL_LIGHT0, GL.GL_DIFFUSE, lightDiffuse, 0); // 拡散光の強さを設定します
		gl.glLightfv(GL.GL_LIGHT0, GL.GL_AMBIENT, lightAmbient, 0); // 環境光の強さを設定します

		gl.glPushMatrix();

		// マウスの移動量に応じて拡大
		gl.glTranslatef(0.0f, 0.0f, vp / 50);

		gl.glPushMatrix();
		// マウスの移動量に応じて移動
		gl.glTranslatef(distanceX / 100, distanceY / 100, 0.0f);

		gl.glPushMatrix(); // 行列を退避します

		//gl.glRotatef(angleX, 1.0f, 0.0f, 0.0f); // X軸で回転
		//gl.glRotatef(angleX, -1.0f, 0.0f, 0.0f);
		//gl.glRotatef(angleY, 0.0f, 1.0f, 0.0f); // Y軸で回転
		gl.glMultMatrixf(Rotate.RMatrix,0);

		// z方向に平行移動をしているため、ここでモデルビュー行列を取得
		gl.glGetDoublev(GL.GL_MODELVIEW_MATRIX, modelview, 0);

		this.drawCubes();
		// gl.glDisable(GL.GL_LIGHTING); // 光源を無効にします
		// gl.glDisable(GL.GL_COLOR_MATERIAL); // カラーマテリアルを無効にします
		// gl.glDisable(GL.GL_LIGHT0); // 0番のライトを無効にします
		//
		// if (latlon == 1) {
		//
		// this.drawMy();
		// }
		//
		// gl.glEnable(GL.GL_LIGHTING); // 光源を有効にします
		// gl.glEnable(GL.GL_COLOR_MATERIAL); // カラーマテリアルを有効にします
		// gl.glEnable(GL.GL_LIGHT0); // 0番のライトを有効にします

		// gl.glPopMatrix(); // 行列を復帰します
		gl.glPopMatrix();
		gl.glPopMatrix();
		gl.glPopMatrix();
		// }

		gl.glFlush(); // 書き込みを指示します
		// temp.count(); // フレーム数のカウント
		// System.out.println(temp.getFrameRate()); //フレームレートの表示
	}

	/** displayメソッドから呼び出されるように分離します */
	public void drawCubes() {

		// 物体の材質の、光源に対する反射率を決めます
		gl.glMaterialfv(GL.GL_FRONT, GL.GL_SPECULAR, cubeSpecular, 0); // ポリゴンの前面にどのくらいの反射か
		gl.glMaterialfv(GL.GL_FRONT, GL.GL_DIFFUSE, cubeDiffuse, 0); // ポリゴンの前面にどのくらいの拡散か
		gl.glMaterialfv(GL.GL_FRONT, GL.GL_AMBIENT, cubeAmbient, 0); // ポリゴンの前面にどのくらいの環境光か
		gl.glMaterialf(GL.GL_FRONT, GL.GL_SHININESS, cubeShiness); // ポリゴンの前面にどのくらいのハイライトか

		// 頂点データ，法線データ，テクスチャ座標の配列を有効にします
		gl.glEnableClientState(GL.GL_VERTEX_ARRAY);
		gl.glEnableClientState(GL.GL_NORMAL_ARRAY);
		gl.glEnableClientState(GL.GL_COLOR_ARRAY);

		// 頂点データオブジェクトのIDを指定します
		gl.glBindBuffer(GL.GL_ARRAY_BUFFER, vboIdVertex);
		gl.glVertexPointer(3, GL.GL_FLOAT, 0, 0);

		// 法線データオブジェクトのIDを指定します
		gl.glBindBuffer(GL.GL_ARRAY_BUFFER, vboIdNormal);
		gl.glNormalPointer(GL.GL_FLOAT, 0, 0);

		// テクスチャ座標オブジェクトのIDを指定します
		gl.glBindBuffer(GL.GL_ARRAY_BUFFER, vboIdcolor);
		gl.glColorPointer(4, GL.GL_FLOAT, 0, 0);

		// 描画します
		gl.glDrawArrays(GL.GL_TRIANGLES, 0, totalindex * 3);// 3角形で表示

		if (latlon == 1) {
			gl.glDisable(GL.GL_LIGHTING); // 光源を無効にします
			gl.glDisable(GL.GL_COLOR_MATERIAL); // カラーマテリアルを無効にします
			gl.glDisable(GL.GL_LIGHT0); // 0番のライトを無効にします

			gl.glEnable(GL.GL_LINE_SMOOTH);
			gl.glEnable(GL.GL_BLEND);
			gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE_MINUS_SRC_ALPHA);
			gl.glHint(GL.GL_LINE_SMOOTH_HINT, GL.GL_DONT_CARE);
			gl.glLineWidth(1.5f);

			gl.glDrawArrays(GL.GL_LINE_STRIP, totalindex * 3, total_latlon_W+total_latlon_R);// よくわからんけど、total_latlonは＊３しなくていいっぽい

			gl.glDisable(GL.GL_LINE_SMOOTH);
			gl.glDisable(GL.GL_BLEND);

			gl.glEnable(GL.GL_LIGHTING); // 光源を有効にします
			gl.glEnable(GL.GL_COLOR_MATERIAL); // カラーマテリアルを有効にします
			gl.glEnable(GL.GL_LIGHT0); // 0番のライトを有効にします
		}

		// 頂点データ，法線データ，テクスチャ座標の配列を無効にします
		gl.glDisableClientState(GL.GL_VERTEX_ARRAY);
		gl.glDisableClientState(GL.GL_NORMAL_ARRAY);
		gl.glDisableClientState(GL.GL_COLOR_ARRAY);

		// 色データの書き換え
		gl.glBindBuffer(GL.GL_ARRAY_BUFFER, vboIdcolor);
		ByteBuffer ptr = gl
				.glMapBufferARB(GL.GL_ARRAY_BUFFER, GL.GL_READ_WRITE);
		if (ptr != null) {
			for (int i = 0; i < totalmapping; i++) {
				ptr.putFloat(M_RGB_0[i][0]);
				ptr.putFloat(M_RGB_0[i][1]);
				ptr.putFloat(M_RGB_0[i][2]);
				ptr.putFloat(M_RGB_0[i][3]);
				ptr.putFloat(M_RGB_0[i][0]);
				ptr.putFloat(M_RGB_0[i][1]);
				ptr.putFloat(M_RGB_0[i][2]);
				ptr.putFloat(M_RGB_0[i][3]);
				ptr.putFloat(M_RGB_0[i][0]);
				ptr.putFloat(M_RGB_0[i][1]);
				ptr.putFloat(M_RGB_0[i][2]);
				ptr.putFloat(M_RGB_0[i][3]);
			}
			// リミットを現在のポジションにセット
			ptr.limit(ptr.position());

			// バッファからのデータの取得に備えてポジションを0にセット
			ptr.position(0);

			gl.glUnmapBuffer(GL.GL_ARRAY_BUFFER);
		}

	}

	

	/** ディスプレイが変更された際に呼ばれる処理です */
	public void displayChanged(GLAutoDrawable arg0, boolean arg1, boolean arg2) {
		
		// TODO Auto-generated method stub
	}

	/** VBOを作成します */
	public void compile(GL gl) {
		/** VBO番号をリセットします */
		vboIdVertex = 0;
		vboIdNormal = 0;
		vboIdcolor = 0;

		System.out.println("debug:VBO関係のバッファをリセットします");

		// バッファオブジェクトの名前を3つ作成します
		int[] vboIdBuff = new int[3];
		gl.glGenBuffers(3, vboIdBuff, 0);

		// １つ目のバッファオブジェクトに頂点データ配列を転送します
		gl.glBindBuffer(GL.GL_ARRAY_BUFFER, vboIdBuff[0]);
		vertexBuffer = this.createVertexBuffer();
		vertexBuffer.flip();
		gl.glBufferData(GL.GL_ARRAY_BUFFER, vertexBuffer.capacity()
				* BufferUtil.SIZEOF_FLOAT, vertexBuffer, GL.GL_STATIC_DRAW);

		// ２つ目のバッファオブジェクトに法線データ配列を転送します
		gl.glBindBuffer(GL.GL_ARRAY_BUFFER, vboIdBuff[1]);
		normalBuffer = this.createNormalBuffer();
		normalBuffer.flip();

		gl.glBufferData(GL.GL_ARRAY_BUFFER, normalBuffer.capacity()
				* BufferUtil.SIZEOF_FLOAT, normalBuffer, GL.GL_STATIC_DRAW);
		

		// ３つ目のバッファオブジェクトにテクスチャ座標配列を転送します
		gl.glBindBuffer(GL.GL_ARRAY_BUFFER, vboIdBuff[2]);
		colorBuffer = this.createColorBuffer();
		colorBuffer.flip();
		gl.glBufferData(GL.GL_ARRAY_BUFFER, colorBuffer.capacity()
				* BufferUtil.SIZEOF_FLOAT, colorBuffer, GL.GL_DYNAMIC_DRAW);
		
		
		vboIdVertex = vboIdBuff[0];
		vboIdNormal = vboIdBuff[1];
		vboIdcolor = vboIdBuff[2];

	}

	/** 頂点バッファの作成です */
	public FloatBuffer createVertexBuffer() {
		float[] floatArray = new float[totalindex * 9 + total_latlon_W * 3 + total_latlon_R * 3];

		for (int i = 0; i < totalindex; i++) {
			floatArray[i * 9] = vertices[(index[i][0] - 1)][0];
			floatArray[i * 9 + 1] = vertices[(index[i][0] - 1)][1];
			floatArray[i * 9 + 2] = vertices[(index[i][0] - 1)][2];
			floatArray[i * 9 + 3] = vertices[(index[i][1] - 1)][0];
			floatArray[i * 9 + 4] = vertices[(index[i][1] - 1)][1];
			floatArray[i * 9 + 5] = vertices[(index[i][1] - 1)][2];
			floatArray[i * 9 + 6] = vertices[(index[i][2] - 1)][0];
			floatArray[i * 9 + 7] = vertices[(index[i][2] - 1)][1];
			floatArray[i * 9 + 8] = vertices[(index[i][2] - 1)][2];
			
		}

		for (int i = 0; i < total_latlon_W; i++) {
			floatArray[((totalindex - 1) * 9 + 8 + 1) + (i * 3)] = latlon_line_W[i][0];
			floatArray[((totalindex - 1) * 9 + 8 + 1) + (i * 3 + 1)] = latlon_line_W[i][1];
			floatArray[((totalindex - 1) * 9 + 8 + 1) + (i * 3 + 2)] = latlon_line_W[i][2];
		}

		for (int i = 0; i < total_latlon_R; i++) {
			floatArray[((totalindex - 1) * 9 + 8 + 1) +((total_latlon_W-1)*3+2+1)+ (i * 3)] = latlon_line_R[i][0];
			floatArray[((totalindex - 1) * 9 + 8 + 1) +((total_latlon_W-1)*3+2+1)+ (i * 3 + 1)] = latlon_line_R[i][1];
			floatArray[((totalindex - 1) * 9 + 8 + 1) +((total_latlon_W-1)*3+2+1)+ (i * 3 + 2)] = latlon_line_R[i][2];
		}

		FloatBuffer fBuff = FloatBuffer.wrap(floatArray);
		System.out.println("debug:頂点バッファを構築しました");
		return fBuff;
	}

	/** 法線バッファの作成です */
	public FloatBuffer createNormalBuffer() {
		float[] floatArray = new float[normalIndex.length * 3];

		for (int i = 0; i < normalIndex.length; i++) {
			floatArray[i * 3] = normals[normalIndex[i]][0];
			floatArray[i * 3 + 1] = normals[normalIndex[i]][1];
			floatArray[i * 3 + 2] = normals[normalIndex[i]][2];
		}

		FloatBuffer fBuff = FloatBuffer.wrap(floatArray);
		System.out.println("debug:法線バッファを構築しました ");
		return fBuff;
	}

	
	/** カラーバッファの作成です */
	public FloatBuffer createColorBuffer() {
		float[] floatArray = new float[(totalmapping * 12) + (total_latlon_W * 4)
				+ (total_latlon_R * 4)];
		for (int i = 0; i < totalmapping; i++) {

			floatArray[i * 12] = M_RGB_0[i][0];
			floatArray[i * 12 + 1] = M_RGB_0[i][1];
			floatArray[i * 12 + 2] = M_RGB_0[i][2];
			floatArray[i * 12 + 3] = M_RGB_0[i][3];
			floatArray[i * 12 + 4] = M_RGB_0[i][0];
			floatArray[i * 12 + 5] = M_RGB_0[i][1];
			floatArray[i * 12 + 6] = M_RGB_0[i][2];
			floatArray[i * 12 + 7] = M_RGB_0[i][3];
			floatArray[i * 12 + 8] = M_RGB_0[i][0];
			floatArray[i * 12 + 9] = M_RGB_0[i][1];
			floatArray[i * 12 + 10] = M_RGB_0[i][2];
			floatArray[i * 12 + 11] = M_RGB_0[i][3];

		}

		for (int i = 0; i < total_latlon_W; i++) {
			floatArray[((totalmapping - 1) * 12 + 11 + 1) + (i * 4)] = 1.0f;
			floatArray[((totalmapping - 1) * 12 + 11 + 1) + (i * 4 + 1)] = 1.0f;
			floatArray[((totalmapping - 1) * 12 + 11 + 1) + (i * 4 + 2)] = 1.0f;
			floatArray[((totalmapping - 1) * 12 + 11 + 1) + (i * 4 + 3)] = 1.0f;
		}



		for (int i = 0; i < total_latlon_R; i++) {
			floatArray[((totalmapping - 1) * 12 + 11 + 1) +((total_latlon_W-1)*4 + 3+1)+ (i * 4)] = 1.0f;
			floatArray[((totalmapping - 1) * 12 + 11 + 1) +((total_latlon_W-1)*4 + 3+1)+ (i * 4 + 1)] = 0.0f;
			floatArray[((totalmapping - 1) * 12 + 11 + 1) +((total_latlon_W-1)*4 + 3+1)+ (i * 4 + 2)] = 0.0f;
			floatArray[((totalmapping - 1) * 12 + 11 + 1) +((total_latlon_W-1)*4 + 3+1)+ (i * 4 + 3)] = 1.0f;
		}

	
		FloatBuffer fBuff = FloatBuffer.wrap(floatArray);
		System.out.println("debug:テクスチャ座標バッファを構築しました ");
		return fBuff;
	}

	/** キーを押したときに呼ばれる処理です */
	public void keyPressed(KeyEvent e) {
		float cameraVectorX = -CAMERASPEED
				* (float) Math.sin(cameraAngle / 180 * Math.PI);
		float cameraVectorZ = -CAMERASPEED
				* (float) Math.cos(cameraAngle / 180 * Math.PI);

		if (e.getKeyChar() == '9') {

		}

		if (e.getKeyChar() == '2') { // 後退
			cameraX -= cameraVectorX;
			cameraZ -= cameraVectorZ;
		}

		if (e.getKeyChar() == '4') {
			latlon = 1;
			data_change(M_C_1);

			System.out.println("ファイル切り替え");
		}

		if (e.getKeyChar() == '5') {
			latlon = 0;
			data_change(M_C_2);

			System.out.println("ファイル切り替え２");

		}

		if (e.getKeyChar() == '6') {

			data_change(M_C_3);

			System.out.println("ファイル切り替え３");

		}

		if (e.getKeyChar() == '1') {

			data_change(M_C_4);
			System.out.println("ファイル切り替え０");

		}

		if (e.getKeyChar() == '0') {

			InitialColor();
			System.out.println("マッピング無し");

		}

		if (e.getKeyChar() == '8') { // 前進
			cameraX += cameraVectorX;
			cameraZ += cameraVectorZ;
		}

	}

	public void keyTyped(KeyEvent e) {
		// TODO 自動生成されたメソッド・スタブ

	}

	public void keyReleased(KeyEvent e) {
		// TODO 自動生成されたメソッド・スタブ

	}

	public void mouseDragged(MouseEvent e) {
		float scale = currentscale - prevMouseY;

		int x = e.getX();
		int y = e.getY();

		if (e.isAltDown()) {
			// 移動量の算出
			vp = (float) (vp + scale);

			// 描画範囲外に出た時の処理
			if (vp <= -550) {
				vp = -550;
			} else if (vp >= 330) {
				vp = 330;
			}
			System.out.println(vp);
		}

		else if (e.isShiftDown()) {
			// 移動量の算出
			float diffX = (float) (x - prevMouseX) / 10.0f;
			float diffY = (float) (prevMouseY - y) / 10.0f;

			// 移動量の更新
			distanceX += diffX;
			distanceY += diffY;
		}

		else if (e.isControlDown()) {
			toRGB();
			float diffY = (float) (prevMouseY - y) / 200;

			color_scale += diffY;
			if (color_scale <= 0.01) {
				color_scale = 0.01f;
			} else if (color_scale >= 3.99) {
				color_scale = 3.99f;
			}
			System.out.println(color_scale);

		}

		/*+else {

			Dimension size = e.getComponent().getSize();
			// 回転量の算出
			// ウィンドウの端から端までで、360度回転するようにする
			float thetaY = 360.0f * ((float) (x - prevMouseX) / size.width);
			float thetaX = 360.0f * ((float) (prevMouseY - y) / size.height);

			// 角度の更新
			angleX -= thetaX;
			angleY += thetaY;
		}*/
		else {
			float dy = x - prevMouseX;
			float dx = y - prevMouseY;
			Rotate.axis[0]=dx;
			Rotate.axis[1]=dy;
			//Rotatew.setAxis(dx,dy);
			//Rotatew.CreateRM();	
			Rotate.CreateRM();
		}

		// 現在のマウスの位置を保存
		prevMouseX = x;
		prevMouseY = y;

	}

	public void mouseMoved(MouseEvent e) {
		// TODO 自動生成されたメソッド・スタブ

	}

	public void mouseClicked(MouseEvent e) {
		requestFocus();
		// マウス座標を[-1, 1]に変換する。正規化したビューボリューム内へ投影したポリゴンと位置の比較
		// をするため
		mouseX = (double) e.getX() - (double) wi / 2;
		mouseY = (-1) * (double) e.getY() + (double) he / 2;

		scale[0] = mouseX / ((double) wi / (double) 2);
		scale[1] = mouseY / ((double) he / (double) 2);

		mousePos = new Point2D.Double(scale[0], scale[1]);

		// クリックされた位置のポリゴンIDをGET

		Integer polygonID = getID();
		int id_no = polygonID.intValue();
		int ID_NO = id_no + 1;

		ID = ID_NO;

		String i = polygonID.toString();

		// Debug
		System.out.println("MousePosition" + mousePos);
		System.out.println("MatchedPolygon:  " + ID_NO);

		System.out.println("Current Color " + M_C_0[id_no]);
		System.out.println(": " + M_C_1[id_no] + " ");
		System.out.println(": " + M_C_2[id_no] + " ");
		System.out.println(": " + M_C_3[id_no] + " ");
		System.out.println(": " + M_C_4[id_no] + " ");

		// ポリゴンIDをこのアプレット埋め込み先のJavaScriptに送信
		// try{
		// JSObject window = JSObject.getWindow(this);
		// Object[] obj = {i, "0", "0"};
		// window.call("hoge", obj);
		//
		// }catch(netscape.javascript.JSException jse){
		// System.out.println("JSE");

		// }
		area1.setText("PolygonID :　" + ID + "\nGravitational potential :　" + M_C_1[id_no] + " km^2/s^2"
				+ "\nSurface slope :　" + M_C_2[id_no] + "°" + "\nAMICA brightness :　" + M_C_3[id_no] + "\nNIRS albedo :　"
				+ M_C_4[id_no] + "\nDegree of space weathering :　" + M_C_5[id_no]);
	}

	public Integer getID() {
		int pid = -1;
		int[] a = new int[100];
		double[] b = new double[100];

		// ポリゴンを検知した数
		count = 0;

		// マウスクリック位置がどのポリゴン内にあるか、各ポリゴンを正規ビューボリュームへ座標変換することで
		// 判定する。
		for (indexP = 0; indexP < totalindex; indexP++) {

			// 三角形ポリゴンの各頂点において、モデルビュー・射影・ビューポート変換を施し、
			// 正規化ビューボリューム[1, -1]へ座標を移す
			gll.gluProject((double) vertices[(index[indexP][0] - 1)][0],
					(double) vertices[(index[indexP][0] - 1)][1],
					(double) vertices[(index[indexP][0] - 1)][2], modelview, 0,
					projection, 0, viewport, 0, result, 0);
			gll.gluProject((double) vertices[(index[indexP][1] - 1)][0],
					(double) vertices[(index[indexP][1] - 1)][1],
					(double) vertices[(index[indexP][1] - 1)][2], modelview, 0,
					projection, 0, viewport, 0, result, 3);
			gll.gluProject((double) vertices[(index[indexP][2] - 1)][0],
					(double) vertices[(index[indexP][2] - 1)][1],
					(double) vertices[(index[indexP][2] - 1)][2], modelview, 0,
					projection, 0, viewport, 0, result, 6);

			// 三角形ポリゴン内にマウスポインタが入っているか判定
			if (includeTRI2(mousePos) == true) {
				
				a[count] = indexP;
				b[count] = (result[2] + result[5] + result[8]) / 3.0d;
				count++;
			}
		}
		System.out.println("Number of Matched Polygon: " + count);

		// ポリゴンを検知した際、検知したポリゴン（おそらくほとんど２つ）の変換されたZ値(result)を比較し

		// 前に出てる方(つまり、ｚ値が最小のもの)を検索し、そのz値を持つポリゴンのIDがポリゴンIDになる
		if (count != 0) {
			int[] matchedlist = new int[count];
			double[] depth = new double[count];

			for (int c = 0; c < count; c++) {
				matchedlist[c] = a[c];
				depth[c] = b[c];
			}

			double min = 1.0d;
			int pidindex = 0;
			for (int d = 0; d < count; d++) {
				if (min > depth[d]) {
					min = depth[d];
					pidindex = d;
				}
			}
			pid = matchedlist[pidindex];
			return new Integer(pid);
		}
		// なんもポリゴンを検知しなかったとき（3Dモデルの外側）は、-1を返す。
		else
			return new Integer(-1);
	}

	public boolean includeTRI2(Point2D.Double mp) {

		// ポリゴンの中心を計算
		Point2D.Double midle = new Point2D.Double(
				(result[0] + result[3] + result[6]) / 3,
				(result[1] + result[4] + result[7]) / 3);

		Point2D.Double[] twoPoints = new Point2D.Double[3];
		twoPoints[0] = new Point2D.Double(result[0], result[1]);
		twoPoints[1] = new Point2D.Double(result[3], result[4]);
		twoPoints[2] = new Point2D.Double(result[6], result[7]);

		// 正規ビューボリュームに投影されたポリゴンの中心点とマウス座標を端とする線分が、ポリゴンの
		// 三角形の角3辺と交差しなかった場合、マウス座標はそのポリゴンの内部にある、つまりポリゴン検知
		if (intersectionEX(twoPoints[0], twoPoints[1], midle, mp) == true)
			return false;
		if (intersectionEX(twoPoints[0], twoPoints[2], midle, mp) == true)
			return false;
		if (intersectionEX(twoPoints[1], twoPoints[2], midle, mp) == true)
			return false;
		return true;
	}

	public boolean intersectionEX(Point2D.Double p1, Point2D.Double p2,
			Point2D.Double p3, Point2D.Double p4) {

		if (((p1.x - p2.x) * (p3.y - p1.y) + (p1.y - p2.y) * (p1.x - p3.x))
				* ((p1.x - p2.x) * (p4.y - p1.y) + (p1.y - p2.y)
						* (p1.x - p4.x)) > 0) {
			return false;
		}
		if (((p3.x - p4.x) * (p1.y - p3.y) + (p3.y - p4.y) * (p3.x - p1.x))
				* ((p3.x - p4.x) * (p2.y - p3.y) + (p3.y - p4.y)
						* (p3.x - p2.x)) > 0) {
			return false;
		}
		return true;
	}

	public void mousePressed(MouseEvent e) {
		prevMouseX = e.getX();
		prevMouseY = e.getY();
		currentscale = prevMouseY;
	}

	public void mouseReleased(MouseEvent e) {
		// TODO 自動生成されたメソッド・スタブ

	}

	public void mouseEntered(MouseEvent e) {
		// TODO 自動生成されたメソッド・スタブ

	}

	public void mouseExited(MouseEvent e) {
		// TODO 自動生成されたメソッド・スタブ

	}

	// スペクトルデータの読み込み関数
	public float[] color_input(java.net.URL mapping_0) {

		float[] M_C;
		ArrayList list = new ArrayList();
		try {
			java.io.InputStream color_in;
			color_in = mapping_0.openStream();

			Scanner scan_c = new Scanner(color_in);

			totalmapping = scan_c.nextInt();
			// M_C_0 = new float[totalmapping];
			M_C = new float[totalmapping];
			M_C_0 = new float[totalmapping];
			M_C_NO = new int[totalmapping];

			for (int i = 0; i < totalmapping; i++) {
				M_C_NO[i] = scan_c.nextInt();
				M_C[i] = scan_c.nextFloat();
				M_C_0[i] = M_C[i];

			}
			scan_c.close();

			toRGB();
			return M_C;

		} catch (IOException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
			M_C = new float[1];
			return M_C;
		}

	}

	// スペクトルデータをRBGに変換
	public void toRGB() {
	//	float separate = (MAX_m - min_m) / 4;

		float r = 0, g = 0, b = 0;
		int region;
		float fraction;
		float min, max, up, down;
 
		int step=1000;
		float number;
		float MR;
		float mR;
		
		M_RGB_0 = new float[totalmapping][4];
		for (int i = 0; i < totalmapping; i++) {
			MR=(min_m+(MAX_m-min_m)*((float)MAXrange/1000.0f));
			mR=(min_m+(MAX_m-min_m)*((float)minrange/1000.0f));
//			System.out.println(mR);
			if(M_C_0[i] == 0){
				M_RGB_0[i][0] = 0.7f;
				M_RGB_0[i][1] = 0.7f;
				M_RGB_0[i][2] = 0.7f;
				M_RGB_0[i][3] = 1.0f;
			}
			else if (MR<M_C_0[i]){//最大値を下げる
				M_RGB_0[i][0] = 1.0f;
				M_RGB_0[i][1] = 0.0f;
				M_RGB_0[i][2] = 0.0f;
				M_RGB_0[i][3] = 1.0f;
			}
			else if (mR>M_C_0[i]){//最大値を下げる
				M_RGB_0[i][0] = 0.0f;
				M_RGB_0[i][1] = 0.0f;
				M_RGB_0[i][2] = 1.0f;
				M_RGB_0[i][3] = 1.0f;
			}
			else {
			number = 999*((M_C_0[i]-mR)/(MR-mR));
			
			number = number % step;
			hue = (end - begin) / step * number + begin;
	
			// 入力データのチェックと補正
			while (hue > 360.0f || hue < 0.0f) {
				if (hue >= 360.0f)
					hue -= 360.0f;
				else if (hue < 0.0f)
					hue += 360.0f;
			}
			if (saturation > 1.0f)
				saturation = 1.0f;
			else if (saturation < 0.0f)
				saturation = 0.0f;
			if (value > 1.0f)
				value = 1.0f;
			else if (value < 0.0f)
				value = 0.0f;

			max = (int) (value);

			if (saturation == 0.0f) {
				r = max;
				g = max;
				b = max;
			} else {
				region = (int) (hue / 60.0f);
				fraction = hue / 60.0f - region;
				min = (int) (max * (1.0f - saturation));
				up = min + fraction * max * saturation;
				down = max - fraction * max * saturation;

				switch (region) {
				case 0:
					M_RGB_0[i][0] = max;
					M_RGB_0[i][1] = up;
					M_RGB_0[i][2] = min;
					M_RGB_0[i][3] = 1.0f;
					break;// 赤→黄
				case 1:
					M_RGB_0[i][0] = down;
					M_RGB_0[i][1] = max;
					M_RGB_0[i][2] = min;
					M_RGB_0[i][3] = 1.0f;
					break;// 黄→緑
				case 2:
					M_RGB_0[i][0] = min;
					M_RGB_0[i][1] = max;
					M_RGB_0[i][2] = up;
					M_RGB_0[i][3] = 1.0f;
					break;// 緑→シアン
				case 3:
					M_RGB_0[i][0] = min;
					M_RGB_0[i][1] = down;
					M_RGB_0[i][2] = max;
					M_RGB_0[i][3] = 1.0f;
					break;// シアン→青
				case 4:
					M_RGB_0[i][0] = up;
					M_RGB_0[i][1] = min;
					M_RGB_0[i][2] = max;
					M_RGB_0[i][3] = 1.0f;
					break;// 青→マゼンタ
				case 5:
					M_RGB_0[i][0] = max;
					M_RGB_0[i][1] = min;
					M_RGB_0[i][2] = down;
					M_RGB_0[i][3] = 1.0f;
					break;// マゼンタ→赤
				}
			}
//			System.out.println((min_m+(MAX_m-min_m)*(MAXrange/1000)));
//			System.out.println((min_m+(MAX_m-min_m)*(minrange/1000)));
			}

		//	System.out.println(M_RGB_0[i][0] + "  " + M_RGB_0[i][1]+ "  " + M_RGB_0[i][2]);

		}

	}

	// マッピングデータの切り替え関数
	public void data_change(float[] M_C_Data) {
//		color_scale = 1.0f;
		MAX_m = 0;
		min_m = 10.0f;

		for (int i = 0; i < totalmapping; i++) {
			M_C_NO[i] = 10;
			M_C_0[i] = M_C_Data[i];

			if (MAX_m < M_C_0[i])
				MAX_m = M_C_0[i];
			if ((min_m > M_C_0[i])&&(min_m!=0))
				min_m = M_C_0[i];
		}
		toRGB();
	}

	// 灰色のイトカワを表示
	public void InitialColor() {
		M_RGB_0 = new float[totalmapping][4];
		for (int i = 0; i < totalmapping; i++) {
			M_RGB_0[i][0] = 0.98f*((color_scale-0.01f)/(9.99f))+0.1f;
			M_RGB_0[i][1] = 0.98f*((color_scale-0.01f)/(9.99f))+0.1f;
			M_RGB_0[i][2] = 0.98f*((color_scale-0.01f)/(9.99f))+0.1f;
			M_RGB_0[i][3] = 1.0f;
		}
	}

	// ボタンのアクション
	public void actionPerformed(ActionEvent event) {
		Object source = event.getSource();
		// 緯線・経線の表示
		if (source == L_L) {
			if (latlon == 0)
				latlon = 1;
			else if (latlon == 1)
				latlon = 0;
		}
		// マッピングデータのクリア
		if (source == CL) {
			Initial =1;
			setMy( d0s_b, d0s_e) ;
			InitialColor();
			lst.clearSelection();		
			System.out.println("マッピング無し");

		}

	}

	// リストのアクション
	public void valueChanged(ListSelectionEvent e) {
		J++;// クリックした時と、離した時の２回valueChangedが呼ばれてしまうためこうした。
		if (J == 1) {
			L = lst.getSelectedIndex();
			if (L == 0) {
				Initial=0;
				data_change(M_C_1);
				setMy( d1s_b, d1s_e) ;
			} else if (L == 1) {
				Initial=0;
				data_change(M_C_2);
				setMy( d2s_b, d2s_e) ;
			} else if (L == 2) {
				Initial=0;
				data_change(M_C_3);
				setMy( d3s_b, d3s_e) ;
			} else if (L == 3) {
				Initial = 0;
				data_change(M_C_4);
				setMy( d4s_b, d4s_e) ;
			} else if (L == 4) {
				Initial = 0;
				data_change(M_C_5);
				setMy( d5s_b, d5s_e) ;
			} 
		}
		if (J == 2) {
			J = 0;
		}

	}

	// スライダーのアクション
	public void stateChanged(ChangeEvent e) {
		color_scale = (float) slider_b.getValue() / 100;
		//System.out.println("値：" + color_scale);
		if (Initial==0){
			if(L==0){
				d1s_b = slider_b.getValue();
		    	d1s_e = slider_e.getValue();
		    	MAXrange=d1s_b;
		    	minrange=d1s_e;
			}
			if(L==1){
				d2s_b = slider_b.getValue();
		    	d2s_e = slider_e.getValue();
		    	MAXrange=d2s_b;
		    	minrange=d2s_e;
				}
			if(L==2){
				d3s_b = slider_b.getValue();
		    	d3s_e = slider_e.getValue();
		    	MAXrange=d3s_b;
		    	minrange=d3s_e;
				}
			if(L==3){
				d4s_b = slider_b.getValue();
		    	d4s_e = slider_e.getValue();
		    	MAXrange=d4s_b;
		    	minrange=d4s_e;
				}
			if(L==4){
				d5s_b = slider_b.getValue();
		    	d5s_e = slider_e.getValue();
		    	MAXrange=d5s_b;
		    	minrange=d5s_e;
				}

		toRGB();
		}
		if (Initial==1){
			d0s_b = slider_b.getValue();
			d0s_e = slider_e.getValue();
		InitialColor() ;
		}
System.out.println("MAX"+MAXrange);
System.out.println("min"+minrange);
	}
	
	public void setMy(int x, int y) {
		slider_b.setValue(x);
		slider_e.setValue(y);
	}


}